unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ADODB, ExtCtrls, ComCtrls, ImgList, StdCtrls, Buttons, UJDRObjects,
  Menus, Mask;

type
  TFormMain = class(TForm)
    PanelMap: TPanel;
    ImageMap: TImage;
    GameObj: TTreeView;
    ImageList: TImageList;
    GameProp: TPageControl;
    FAera: TTabSheet;
    FMaps: TTabSheet;
    FPlayers: TTabSheet;
    FPnj: TTabSheet;
    MapCombo: TComboBox;
    MapName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    MapMemo: TMemo;
    MapCreateBtn: TBitBtn;
    ZoomBar: TTrackBar;
    Timer1: TTimer;
    Label4: TLabel;
    CtrlTree: TTreeView;
    SaveBtn: TBitBtn;
    Label5: TLabel;
    PnjName: TEdit;
    PnjCreateBtn: TBitBtn;
    PnjMemo: TMemo;
    ObjectMenu: TPopupMenu;
    Delete: TMenuItem;
    Find: TMenuItem;
    N1: TMenuItem;
    FEvents: TTabSheet;
    AeraName: TEdit;
    Label3: TLabel;
    AeraCreateBtn: TBitBtn;
    AeraMemo: TMemo;
    Label6: TLabel;
    PlayerName: TEdit;
    PlayerCreateBtn: TBitBtn;
    PlayerMemo: TMemo;
    Newdirectory1: TMenuItem;
    N2: TMenuItem;
    MapCancelBtn: TBitBtn;
    AeraCancelBtn: TBitBtn;
    PnjCancelBtn: TBitBtn;
    PlayerCancelBtn: TBitBtn;
    LoadBtn: TButton;
    Label7: TLabel;
    PlayerTeam: TComboBox;
    Port: TEdit;
    ServeBtn: TSpeedButton;
    Control: TEdit;
    Finder: TBitBtn;
    ClientBtn: TSpeedButton;
    PanelTime: TPanel;
    TimeMap: TImage;
    IP: TEdit;
    ForceUnlock: TMenuItem;
    ForceLock: TMenuItem;
    N3: TMenuItem;
    Nick: TEdit;
    Label8: TLabel;
    Chat: TEdit;
    ChatMemo: TMemo;
    Label9: TLabel;
    MapProxW: TEdit;
    ProxyMemo: TListBox;
    Label10: TLabel;
    Label11: TLabel;
    TimeBox: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    TotalTime: TEdit;
    DayTime: TEdit;
    PercLight: TEdit;
    PercDawn: TEdit;
    PercNight: TEdit;
    RealClock: TEdit;
    HoursTime: TEdit;
    Label17: TLabel;
    GameClock: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    TimePlayBtn: TSpeedButton;
    GameMinutes: TEdit;
    Label20: TLabel;
    EventName: TEdit;
    EventCancelBtn: TBitBtn;
    EventCreateBtn: TBitBtn;
    EventMemo: TMemo;
    Label21: TLabel;
    Label22: TLabel;
    EventPerc: TEdit;
    EventIndex: TEdit;
    EventActive: TCheckBox;
    PnjMonster: TCheckBox;
    PnjColour: TComboBox;
    Label23: TLabel;
    InfosPop: TLabel;
    PlayerFThumb: TImage;
    PlayerEThumb: TImage;
    PlayerDThumb: TImage;
    PlayerCThumb: TImage;
    PlayerBThumb: TImage;
    PlayerAThumb: TImage;
    AeraThumb: TImage;
    PnjAThumb: TImage;
    PnjBThumb: TImage;
    PnjCThumb: TImage;
    PnjDThumb: TImage;
    PnjEThumb: TImage;
    PnjFThumb: TImage;
    PnjMFThumb: TImage;
    PnjMEThumb: TImage;
    PnjMDThumb: TImage;
    PnjMCThumb: TImage;
    PnjMBThumb: TImage;
    PnjMAThumb: TImage;
    procedure FormCreate(Sender: TObject);
    procedure ImageMapDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure GameObjDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure GameObjDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ImageMapDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ZoomBarChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PanelMapDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure PanelMapDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SaveBtnClick(Sender: TObject);
    procedure DeleteClick(Sender: TObject);
    procedure FindClick(Sender: TObject);
    procedure GameObjChange(Sender: TObject; Node: TTreeNode);
    procedure GameObjDblClick(Sender: TObject);
    procedure Newdirectory1Click(Sender: TObject);
    procedure MapCancelBtnClick(Sender: TObject);
    procedure MapCreateBtnDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure LoadBtnClick(Sender: TObject);
    procedure AeraCancelBtnClick(Sender: TObject);
    procedure AeraCreateBtnDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure PnjCreateBtnDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure PlayerCreateBtnDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure MapCreateBtnDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PnjCancelBtnClick(Sender: TObject);
    procedure PlayerCancelBtnClick(Sender: TObject);
    procedure ServeBtnClick(Sender: TObject);
    procedure ImageThumbMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FinderClick(Sender: TObject);
    procedure ForceLockClick(Sender: TObject);
    procedure ForceUnlockClick(Sender: TObject);
    procedure ChatKeyPress(Sender: TObject; var Key: Char);
    procedure GameObjEdited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure TotalTimeExit(Sender: TObject);
    procedure DayTimeExit(Sender: TObject);
    procedure PercLightExit(Sender: TObject);
    procedure PercDawnExit(Sender: TObject);
    procedure PercNightExit(Sender: TObject);
    procedure TimePlayBtnClick(Sender: TObject);
    procedure GameMinutesExit(Sender: TObject);
    procedure EventCancelBtnClick(Sender: TObject);
    procedure EventCreateBtnDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure TimeMapDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TimeMapDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ImageMapMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    SX, SY: Integer;
    ControledObject: TJDRObject;
    InfoObject: TMovable;
    EditedJDRobject: TJDRObject;
    EditedNode: TTreeNode;

  public
    { Public declarations }
    ActiveMap: TMap;

    procedure AffectMap(VMap: TMap);
    procedure MoveImageMap(Absol: boolean; RX, RY: Integer);
    procedure MoveMovable(Absol: Boolean; Source: TImage; RX, RY: Integer);
    procedure RefreshThumbs;
    procedure FreeMap;
    procedure FreeObjects;
    function  PnjThumb(VMonster: Boolean; VColour: Integer): TImage;
    function  TeamThumb(Index: Integer): TImage;
    procedure ListManagment(ActionMode: Integer);
    function  Newdirectory: TDirectory;
    procedure DrawTimeMap;
    function  SaveClocksSerial: String;
    procedure LoadClocksSerial(Serial: String);
    procedure CancelBtnClick;
    procedure TimePanelColor;
    procedure ActiveEvent(Event: TEvent);
  end;

var
  FormMain: TFormMain;

implementation

uses UDMod;

{$R *.dfm}




// Initialisation du formulaire
procedure TFormMain.FormCreate(Sender: TObject);
begin
  // Chargement de la liste des MAPs
  MapCombo.Clear;
  DMod.LoadDirIntoCombo(ExtractFilePath(Application.ExeName) + 'Maps\*.jpg', MapCombo);
  EditedJDRobject := nil;
  EditedNode := nil;
  DMod.AllObjects := GameObj.Items;
  DrawTimeMap;
end;

// Affecte une carte et l'affiche
procedure TFormMain.AffectMap(VMap: TMap);
begin
  if (ActiveMap <> VMap) then begin
    ActiveMap := VMap;
    ActiveMap.DeclarePanel(PanelMap);
    ZoomBar.Position := 0;
    Timer1.Tag := 2;
    Timer1.OnTimer(Self);
    RefreshThumbs;
  end;
end;

procedure TFormMain.FreeMap;
begin
  ActiveMap := nil;
  Timer1.Enabled := False;
  ImageMap.Visible := False;
  ImageMap.Enabled := False;
  ImageMap.Picture.Bitmap.FreeImage;
  RefreshThumbs;
end;

procedure TFormMain.FreeObjects;
var Boucle: Integer;
    Data  : TObject;
begin
  Boucle := 0;
  while (Boucle < GameObj.Items.Count) do begin
    if (assigned(GameObj.Items[boucle].Data)) then begin
      Data := GameObj.Items[boucle].Data;
      Data.Free;
    end else inc(Boucle);
  end;
  GameObj.Items.Clear;
end;

// Dplace relativement l'image de la carte
procedure TFormMain.MoveImageMap(Absol: boolean; RX, RY: Integer);
var L,T,W,H,PW,PH: integer; // Left Top Width Height ParentWidth ParentHeight
begin
  L := ImageMap.left; T := ImageMap.top; W := ImageMap.width; H := ImageMap.height; PW := ImageMap.Parent.Width; PH := ImageMap.Parent.Height;

  if (Absol) then begin
    L := (PW div 2) - RX;
    T := (PH div 2) - RY;
  end else begin
    L := L + RX;
    T := T + RY;
  end;
  // Vrification des largeurs
  if (W < PW) then begin
    L := (PW - W) div 2;
  end else begin
    if ((L + W) < PW) then begin
      L := PW - W;
    end;
    if (L >= 0) then begin
      L := 0;
    end;
  end;

  // Vrification des hauteurs
  if (H < PH) then begin
    T := (PH - H) div 2;
  end else begin
    if ((T + H) < PH) then begin
      T := PH - H;
    end;
    if (T >= 0) then begin
      T := 0;
    end;
  end;

  // Affectation des nouvelles coordonnes
  ImageMap.Left := L; ImageMap.Top := T;
  RefreshThumbs;
  PanelMap.Refresh;
end;

// Dplace l'image d'un PNJ
procedure TFormMain.MoveMovable(Absol: boolean; Source: TImage; RX, RY: Integer);
var L,T: integer; // Left Top
    DataMov: TMovable;
begin
  DataMov := TMovable(Source.Tag);
  if (DataMov.Locked = 0) then begin
    if (Absol) then begin
      L := RX;
      T := RY;
    end else begin
      L := Source.left + (Source.width div 2) - ImageMap.Left + RX;
      T := Source.top + (Source.height div 2) - ImageMap.Top + RY;
    end;
    DataMov.SetPos(ActiveMap, L, T);
    DataMov.Display(ImageMap);
  end;
end;

procedure TFormMain.RefreshThumbs;
var Node   : TTreeNode;
    Data   : TObject;
    DataMov: TMovable;
begin
  Node := GameObj.Items.GetFirstNode;
  while (assigned(Node)) do begin
    Data := Node.Data;
    if (Data is TMovable) then begin
      DataMov := TMovable(Data);
      if (DataMov.Map = ActiveMap) then
        DataMov.Display(ImageMap)
      else
        DataMov.Hide;
    end;
    Node := Node.GetNext;
  end;
end;

function  TFormMain.PnjThumb(VMonster: Boolean; VColour: Integer): TImage;
begin
  if (VMonster) then begin
    case VColour of
    1: Result := PnjMAThumb;
    2: Result := PnjMBThumb;
    3: Result := PnjMCThumb;
    4: Result := PnjMDThumb;
    5: Result := PnjMEThumb;
    6: Result := PnjMFThumb;
    else
      Result := PnjMAThumb;
    end;
  end else begin
    case VColour of
    1: Result := PnjAThumb;
    2: Result := PnjBThumb;
    3: Result := PnjCThumb;
    4: Result := PnjDThumb;
    5: Result := PnjEThumb;
    6: Result := PnjFThumb;
    else
      Result := PnjAThumb;
    end;
  end;
end;

function TFormMain.TeamThumb(Index: Integer): TImage;
begin
  case Index of
  1: Result := PlayerAThumb;
  2: Result := PlayerBThumb;
  3: Result := PlayerCThumb;
  4: Result := PlayerDThumb;
  5: Result := PlayerEThumb;
  6: Result := PlayerFThumb;
  else
    Result := PlayerAThumb;
  end;
end;


// --------------------------------------------------

// Gestion du zoom
procedure TFormMain.ZoomBarChange(Sender: TObject);
begin
  if (abs(ZoomBar.Position) < 10) then ZoomBar.Position := 0;
  Timer1.Enabled := False;
  Timer1.Interval := 100;
  Timer1.Tag := 1;
  Timer1.Enabled := True;
end;

// Timer processeur
procedure TFormMain.Timer1Timer(Sender: TObject);
var X, Y: Integer;
    PX, PY: Double;
begin
  Timer1.Enabled := False;
  case Timer1.Tag of
  // Repaint rapide de l'image (variable:Map), appel le 2 automatiquement
  1:if (assigned(ActiveMap)) then begin
      CtrlTree.Items[CCTRL_AFF].ImageIndex := CICON_YELLOW;
      CtrlTree.Repaint;

      PX := (-ImageMap.Left + (PanelMap.Width / 2)) / ImageMap.Width;
      PY := (-ImageMap.Top + (PanelMap.Height / 2)) / ImageMap.Height;
      ActiveMap.AffectSized(ZoomBar.Position, false);
      ImageMap.Width := ActiveMap.CurSizeX;
      ImageMap.Height := ActiveMap.CurSizeY;
      X := trunc((-PX * ImageMap.Width) + (PanelMap.Width / 2));
      Y := trunc((-PY * ImageMap.Height) + (PanelMap.Height / 2));
      MoveImageMap(false, X - ImageMap.Left, Y - ImageMap.Top);
      ImageMap.Enabled := True;
      ImageMap.Visible := True;

      Timer1.Interval := 2000;
      Timer1.Tag := 2;
      Timer1.Enabled := True;
    end;

  // Repaint dtaill de l'image (long)
  2:if (assigned(ActiveMap)) then begin
      CtrlTree.Items[CCTRL_AFF].ImageIndex := CICON_RED;
      CtrlTree.Repaint;
      ActiveMap.AffectSized(ZoomBar.Position, true);
      ImageMap.Width := ActiveMap.CurSizeX;
      ImageMap.Height := ActiveMap.CurSizeY;
      ImageMap.Picture.Bitmap := ActiveMap.Bitmap;
      MoveImageMap(false, 0,0);
      ImageMap.Enabled := True;
      ImageMap.Visible := True;
      CtrlTree.Items[CCTRL_AFF].ImageIndex := CICON_GREEN;
    end;
  end;
end;


// -----------------------------
// --- Drag & Drop functions ---
// -----------------------------

// PanelMap encapsule l'image de la carte
procedure TFormMain.PanelMapDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  // Si c'est un objet de l'arbre, on l'accepte
  if (Source is TTreeView) then Accept := True
  // Autre chose, on refuse le drop
  else Accept := False;
end;

procedure TFormMain.PanelMapDragDrop(Sender, Source: TObject; X, Y: Integer);
var Data: TObject;
    DataMovable: TMovable;
    Boucle, Offset, Cpt: Integer;
begin
  if (Source is TTreeView) then begin
    with Source as TTreeView do begin
      // La carte recoit un objet, on l'analyse
      Data := Selected.Data;
      if (Data is TMap) then begin
        // C'est un objet carte, on l'affiche
        AffectMap(TMap(Data));
      end else if ((Data is TMovable) and (assigned(ActiveMap))) then begin
        // C'est un objet dplacable, on le configure et l'affiche
        DataMovable := TMovable(Data);
        If (DataMovable.Locked = 0) then begin
          DataMovable.SetPos(ActiveMap, X, Y);
          DataMovable.Display(ImageMap);
        end;
      end else if ((Data is TDirectory) and (assigned(ActiveMap))) then begin
        // Tous les movables d'un rpertoire
        //Offset := Y;
        Cpt := 0;
        for Boucle:= 0 to Selected.Count-1 do begin
          Data := Selected.Item[Boucle].Data;
          if (Data is TMovable) then inc(Cpt);
        end;
        Offset := Y - (7 * Cpt);
        if (Offset < 0) then Offset := 0;
        if (Cardinal(Offset + (14 * (Cpt - 1))) > ActiveMap.CurSizeY) then Offset := Integer(ActiveMap.CurSizeY) - (14 * Cpt);
        for Boucle:= 0 to Selected.Count-1 do begin
          Data := Selected.Item[Boucle].Data;
          if (Data is TMovable) then begin
            DataMovable := TMovable(Data);
            If (DataMovable.Locked = 0) then begin
              inc(Offset, 14);
              DataMovable.SetPos(ActiveMap, X, Offset);
              DataMovable.Display(ImageMap);
            end;
          end;
        end;
      end;
    end;
  end;
end;

// ---

// ImageMap est l'image de la carte
procedure TFormMain.ImageMapDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  // On renvoi le drop au Panel (qui est le parent)
  PanelMapDragDrop(Sender, Source, X, Y);
end;

procedure TFormMain.ImageMapDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if (Source is TImage) then begin
    // En cas de drag-drop de l'image map, on la dplace
    if (State <> dsDragEnter) then begin
      // La souris bouge, calcul de la nouvelle coordonne
      if (TImage(Source).Tag = 0) then
        MoveImageMap(false, X - SX, Y - SY)
      else
        if (Sender = Source) then
          MoveMovable(false, TImage(Source), X - SX, Y - SY)
        else if (Sender is TImage) then if (TImage(Sender).Tag = 0) then MoveMovable(true, TImage(Source), X, Y)
    end else begin
      // Premier click, initialisation des coordonnes
      SX := X;
      SY := Y;
    end;
    Accept := True;

    // Si une image est en attente de calcul, on remet le timer  zero pour ne pas gner le dplacement
    if (Timer1.Enabled) then begin
      Timer1.Enabled := False;
      Timer1.Enabled := True;
    end;

  // Si c'est un objet de l'arbre, on l'accepte
  end else if (Source is TTreeView) then Accept := True
  // Autre chose, on refuse le drop
  else Accept := False;
end;

procedure TFormMain.ImageThumbMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var Boucle: Integer;
    JDRObject: TJDRObject;
    Movable: TMovable;
    Str: String;
begin
  if (Sender is TImage) then begin
    JDRObject := TJDRObject(TImage(Sender).Tag);
    if (ControledObject <> JDRObject) then begin
      Str := JDRObject.ClassName + ': ' + JDRObject.Name;
      if (JDRObject is TMovable) then begin
        Movable := TMovable(JDRObject);
        if (assigned(Movable.Map)) then Str := Str + ' (' + Movable.Map.Name + ')';
      end;
      Control.Text := Str;
      ControledObject := JDRObject;
    end;
    if ((InfoObject <> JDRObject) or (JDRObject is TMovable)) then begin
      // Popup infos movable
      if (assigned(InfoObject)) then InfoObject.MapLabel.Visible := True;
      Movable := TMovable(JDRObject);
      Movable.MapLabel.Visible := False;
      InfosPop.Left := Movable.MapThumb.Left + 16;
      InfosPop.Top := Movable.MapThumb.Top;
      Str := '--' + Movable.Name + '--';
      for Boucle:=0 to Movable.Comments.Count-1 do Str := Str + LF + Movable.Comments[Boucle];
      InfosPop.Caption := Str;
      InfosPop.Visible := True;
      InfosPop.BringToFront;
      InfoObject := Movable;
    end;
  end;
end;

procedure TFormMain.ImageMapMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if (assigned(InfoObject)) then begin
    InfoObject.MapLabel.Visible := True;
    InfosPop.Visible := False;
    InfoObject := nil;
  end;
end;


// ---

// GameObj est l'arbre des objets stocks
procedure TFormMain.GameObjDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var TreeNode: TTreeNode;
begin
  if (Source is TImage) then
    Accept := (TJDRObject(TImage(Source).Tag) is TMovable)
  else begin
    TreeNode := GameObj.GetNodeAt(X, Y);
    Accept := (TreeNode <> nil);
    if ((Accept) and (Source is TTreeView)) then
      if (TJDRObject(TTreeView(Source).Selected.Data) is TDirectory) then accept := False;
  end;
end;

procedure TFormMain.GameObjDragDrop(Sender, Source: TObject; X, Y: Integer);
var Node: TTreeNode;
    Str: String;
    Target: TTreeNode;
    Boucle: Cardinal;
    Save: TList;
    JDRObject: TJDRObject;
begin
  Target := GameObj.GetNodeAt(X, Y);
  // Un TMovable va de la carte vers l'arbre, on le retire de la carte
  if (Source is TImage) then begin
    JDRObject := TJDRObject(TImage(Source).Tag);
    if (JDRObject is TMovable) then begin
      with TMovable(JDRObject) do begin
        if (InfoObject = JDRObject) then begin
          InfoObject := nil;
          InfosPop.Visible := False;
        end;
        Map := nil;
        Hide;
        Modified := True;
      end;
    end;
  end else

  if (assigned(Target)) then begin
    // Dplacement d'objets  l'intrieur de l'arbre
    if (Source is TTreeView) then begin
      with Source as TTreeView do begin
        Items.BeginUpdate;
        Save := TList.Create;
        Boucle := 0;
        While (SelectionCount > Boucle) do begin
          Save.Add(Selections[Boucle]);
          inc(Boucle);
        end;
        While (Save.Count > 0) do begin
          Node := Save.Items[0];
          if (not(TJDRObject(Node.data) is TDirectory)) then begin
            Str := DMod.CStr(TJDRObject(Node.Data).ObjID) + LF + DMod.CStr(TJDRObject(Target.Data).ObjID) + LF + '!END-MOVE' + LF;
            if (TJDRObject(Target.data) is TDirectory) then begin
              Node.MoveTo(Target, naAddChild);
              Str := '!MOVE' + LF + 'CHILD' + LF + Str;
            end else begin
              Node.MoveTo(Target, naAdd);
              Str := '!MOVE' + LF + 'ADD' + LF + Str;
            end;
            DMod.ToServer(Str);
            GameObj.AlphaSort(True);
          end;
          Save.Delete(0);
        end;
        Save.Free;
        Items.EndUpdate;
      end;
    end else

    if (Source is TBitBtn) then begin
      with Source as TBitBtn do begin
        JDRObject := nil;
        // Creation d'un nouveau noeud pour un objet Map
        if (Name = 'MapCreateBtn') then begin
          JDRObject := TMap.Create(Target, MapName.Text, MapMemo.Lines, MapCombo.Text, round(DMod.CVal(MapProxW.Text)));
        end else
        // Creation d'un nouveau noeud pour un objet Pnj
        if (Name = 'PnjCreateBtn') then begin
          JDRObject := TPnj.Create(Target, PnjName.Text, PnjMemo.Lines, PnjThumb(PnjMonster.Checked, PnjColour.ItemIndex+1), FormMain, PanelMap, ImageMapDragOver, ImageThumbMouseMove);
          if (assigned(JDRObject)) then TPnj(JDRObject).SetType(PnjMonster.Checked, PnjColour.ItemIndex+1, nil);
        end else
        // Creation d'un nouveau noeud pour un objet Aera
        if (Name = 'AeraCreateBtn') then begin
          JDRObject := TAera.Create(Target, AeraName.Text, AeraMemo.Lines, AeraThumb, FormMain, PanelMap, ImageMapDragOver, ImageThumbMouseMove);
        end else
        // Creation d'un nouveau noeud pour un objet Player
        if (Name = 'PlayerCreateBtn') then begin
          JDRObject := TPlayer.Create(Target, PlayerName.Text, PlayerMemo.Lines, TeamThumb(PlayerTeam.ItemIndex+1), FormMain, PanelMap, ImageMapDragOver, ImageThumbMouseMove);
          if (assigned(JDRObject)) then TPLayer(JDRObject).SetTeam(PlayerTeam.ItemIndex+1, nil)
        end else
        if (Name = 'EventCreateBtn') then begin
          JDRObject := TEvent.Create(Target, EventName.Text, EventMemo.Lines, EventIndex.Text, EventActive.Checked);
        end;
        if (assigned(JDRObject)) then
          DMod.ToServer('!CREATE' + LF + DMod.CStr(TJDRObject(Target.Data).ObjID) + LF + JDRObject.Serialization + LF + '!END-CREATE' + LF);
        GameObj.AlphaSort(True);
      end;
    end;
  end;
end;

// -------------------------
// --- Properties pannel ---
// -------------------------

procedure TFormMain.GameObjDblClick(Sender: TObject);
var Data: TJDRObject;
    Node: TTreeNode;
    Map : TMap;
    Aera: TAera;
    Pnj : TPnj;
    Player: TPlayer;
    Event: TEvent;
begin
  Node := GameObj.Selected;
  Data := Node.Data;
  if (assigned(Data)) then begin
    if (Data.Locked = 0) then begin
      CancelBtnClick;
      DMod.LockObj(Data);
      EditedJDRobject := Data;
      EditedNode := Node;
      MapCancelBtn.Enabled := false;
      AeraCancelBtn.Enabled := false;
      PnjCancelBtn.Enabled := false;
      PlayerCancelBtn.Enabled := false;

      if (Data is TMap) then begin
        Map := TMap(Data);
        MapName.Text := Map.Name;
        MapCombo.Text := Map.Image;
        MapProxW.Text := DMod.CStr(Map.ProxW);
        MapMemo.Clear;
        MapMemo.Lines.AddStrings(Map.Comments);
        MapCancelBtn.Enabled := true;
        GameProp.ActivePageIndex := 0;

      end else if (Data is TAera) then begin
        Aera := TAera(Data);
        AeraName.Text := Aera.Name;
        AeraMemo.Clear;
        AeraMemo.Lines.AddStrings(Aera.Comments);
        AeraCancelBtn.Enabled := true;
        GameProp.ActivePageIndex := 1;

      end else if (Data is TPnj) then begin
        Pnj := TPnj(Data);
        PnjName.Text := Pnj.Name;
        PnjMemo.Clear;
        PnjMemo.Lines.AddStrings(Pnj.Comments);
        PnjMonster.Checked := Pnj.Monster;
        PnjColour.ItemIndex := Pnj.Colour - 1;
        PnjCancelBtn.Enabled := true;
        GameProp.ActivePageIndex := 2;

      end else if (Data is TPlayer) then begin
        Player := TPlayer(Data);
        PlayerName.Text := Player.Name;
        PlayerMemo.Clear;
        PlayerMemo.Lines.AddStrings(Player.Comments);
        PlayerTeam.ItemIndex := Player.Team - 1;
        PlayerCancelBtn.Enabled := true;
        GameProp.ActivePageIndex := 3;

      end else if (Data is TEvent) then begin
        Event := TEvent(Data);
        EventName.Text := Event.Name;
        EventMemo.Clear;
        EventMemo.Lines.AddStrings(Event.Comments);
        if (Event.TimePerc >= 0) then EventPerc.Text := DMod.CStr(Round(Event.TimePerc * 100));
        EventIndex.Text := Event.Index;
        EventActive.Checked  := Event.Active;
        EventCancelBtn.Enabled := true;
        GameProp.ActivePageIndex := 4;
      end else EditedJDRobject := nil;
    end;
  end;
end;

// Simples clicks sur les boutons drag/drop (validation)
procedure TFormMain.MapCreateBtnDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := False;
  if (Source is TBitBtn) then begin
    if ((MapCancelBtn.Enabled) and (TBitBtn(Source).Name = 'MapCreateBtn')) then Accept := true;
  end;
end;
procedure TFormMain.AeraCreateBtnDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := False;
  if (Source is TBitBtn) then begin
    if ((AeraCancelBtn.Enabled) and (TBitBtn(Source).Name = 'AeraCreateBtn')) then Accept := true;
  end;
end;
procedure TFormMain.PnjCreateBtnDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := False;
  if (Source is TBitBtn) then begin
    if ((PnjCancelBtn.Enabled) and (TBitBtn(Source).Name = 'PnjCreateBtn')) then Accept := true;
  end;
end;
procedure TFormMain.PlayerCreateBtnDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := False;
  if (Source is TBitBtn) then begin
    if ((PlayerCancelBtn.Enabled) and (TBitBtn(Source).Name = 'PlayerCreateBtn')) then Accept := true;
  end;
end;
procedure TFormMain.EventCreateBtnDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := False;
  if (Source is TBitBtn) then begin
    if ((EventCancelBtn.Enabled) and (TBitBtn(Source).Name = 'EventCreateBtn')) then Accept := true;
  end;
end;
// Drop (click)
procedure TFormMain.MapCreateBtnDragDrop(Sender, Source: TObject; X, Y: Integer);
var JDRObject: TJDRObject;
    Map: TMap;
    Aera: TAera;
    Pnj: TPnj;
    Player: TPlayer;
    Event: TEvent;
begin
  if (assigned(EditedJDRobject)) then begin
    JDRObject := EditedJDRObject;
    JDRObject.Modified := True;
    if (JDRObject is TMap) then begin
      Map := TMap(JDRObject);
      Map.Name := MapName.Text;
      if (MapCombo.Text <> Map.Image) then begin
        if (ActiveMap = Map) then FreeMap;
        Map.LoadImage(MapCombo.Text);
      end;
      Map.ProxW := Round(DMod.CVal(MapProxW.Text));
      Map.Comments.Clear;
      Map.Comments.AddStrings(MapMemo.Lines);
      EditedNode.Text := Map.Name;
      MapCancelBtnClick(self);

    end else if (JDRObject is TAera) then begin
      Aera := TAera(JDRObject);
      Aera.Name := AeraName.Text;
      Aera.Comments.Clear;
      Aera.Comments.AddStrings(AeraMemo.Lines);
      EditedNode.Text := Aera.Name;
      AeraCancelBtnClick(self);

    end else if (JDRObject is TPnj) then begin
      Pnj := TPnj(JDRObject);
      Pnj.Name := PnjName.Text;
      Pnj.Comments.Clear;
      Pnj.Comments.AddStrings(PnjMemo.Lines);
      Pnj.SetType(PnjMonster.Checked, PnjColour.ItemIndex+1, PnjThumb(PnjMonster.Checked, PnjColour.ItemIndex+1));
      EditedNode.Text := Pnj.Name;
      PnjCancelBtnClick(self);

    end else if (JDRObject is TPlayer) then begin
      Player := TPlayer(JDRObject);
      Player.Name := PlayerName.Text;
      Player.Comments.Clear;
      Player.Comments.AddStrings(PlayerMemo.Lines);
      Player.SetTeam(PlayerTeam.ItemIndex+1, TeamThumb(PlayerTeam.ItemIndex+1));
      EditedNode.Text := Player.Name;
      PlayerCancelBtnClick(self);

    end else if (JDRObject is TEvent) then begin
      Event := TEvent(JDRObject);
      Event.Name := EventName.Text;
      Event.Comments.Clear;
      Event.Comments.AddStrings(EventMemo.Lines);
      Event.Index := EventIndex.Text;
      Event.Active := EventActive.Checked;
      EditedNode.Text := Event.Name;
      EventCancelBtnClick(self);
      DrawTimeMap;
    end;
    if (JDRObject is TMovable) then TMovable(JDRObject).MapLabel.Caption := JDRObject.Name;
  end;
end;

// Cancels
procedure TFormMain.CancelBtnClick;
begin
  if (assigned(EditedJDRobject)) then DMod.UnLockObj(EditedJDRobject);
  EditedJDRobject := nil;
  EditedNode := nil;
  MapCancelBtn.Enabled := false;
  AeraCancelBtn.Enabled := false;
  PnjCancelBtn.Enabled := false;
  PlayerCancelBtn.Enabled := false;
  EventCancelBtn.Enabled := false;
  EventPerc.Text := '';
end;
procedure TFormMain.MapCancelBtnClick(Sender: TObject);
begin
  CancelBtnClick;
end;
procedure TFormMain.AeraCancelBtnClick(Sender: TObject);
begin
  CancelBtnClick;
end;
procedure TFormMain.PnjCancelBtnClick(Sender: TObject);
begin
  CancelBtnClick;
end;
procedure TFormMain.PlayerCancelBtnClick(Sender: TObject);
begin
  CancelBtnClick;
end;
procedure TFormMain.EventCancelBtnClick(Sender: TObject);
begin
  CancelBtnClick;
end;

// -------------------------
// --- GameObj functions ---
// -------------------------

// Action: 1: Lock / 2: Unlock / 3: Delete
procedure TFormMain.ListManagment(ActionMode: Integer);
var Data: TJDRObject;
    Node: TTreeNode;
    Boucle: Cardinal;
    Save: TList;
begin
  With GameObj do begin
    Items.BeginUpdate;
    Save := TList.Create;
    Boucle := 0;
    While (SelectionCount > Boucle) do begin
      Save.Add(Selections[Boucle]);
      inc(Boucle);
    end;
    While (Save.Count > 0) do begin
      Node := Save.Items[0];
      Data := Node.Data;
      case ActionMode of
      1:if (assigned(Data)) then begin
          DMod.LockObj(Data);
          Data.Locked := 2;
          Data.SetIcon;
        end;
      2:if (assigned(Data)) then begin
          DMod.UnLockObj(Data);
          Data.Locked := 2;
          Data.SetIcon;
        end;
      3:if ((assigned(Data)) and (Node.Count = 0)) then begin
          if (EditedJDRobject = Data) then CancelBtnClick;
          if (Data = ActiveMap) then FreeMap;
          DMod.ToServer('!DELETE' + LF + DMod.CStr(Data.ObjID) + LF + '!END-DELETE' + LF);
          Data.Free;
        end;
      end;
      Save.Delete(0);
    end;
    Save.Free;
    Items.EndUpdate;
  end;
end;

procedure TFormMain.ForceLockClick(Sender: TObject);
begin
  ListManagment(1);
end;
procedure TFormMain.ForceUnlockClick(Sender: TObject);
begin
  ListManagment(2);
end;
procedure TFormMain.DeleteClick(Sender: TObject);
begin
  ListManagment(3);
end;

procedure TFormMain.FindClick(Sender: TObject);
var Data: TObject;
    Node: TTreeNode;
begin
  Node := GameObj.Selected;
  Data := Node.Data;
  if (Data is TMap) then AffectMap(TMap(Data))
  else if (Data is TMovable) then begin
    AffectMap(TMovable(Data).Map);
    MoveImageMap(true, trunc(TMovable(Data).PercX * ActiveMap.CurSizeX), trunc(TMovable(Data).PercY * ActiveMap.CurSizeY));
  end;
end;

procedure TFormMain.GameObjChange(Sender: TObject; Node: TTreeNode);
var JDRObject: TJDRObject;
begin
  JDRObject := Node.Data;
  GameObj.ReadOnly := not (JDRObject is TDirectory);
end;

function TFormMain.Newdirectory: TDirectory;
var TempNode, Node: TTreeNode;
begin
  // Libration des objets
  TempNode := nil;
  Node := GameObj.Items.GetFirstNode;
  if (not assigned(Node)) then begin
    TempNode := FormMain.GameObj.Items.Add(nil, '** Loading **');
    Node := TempNode;
  end;
  Result := TDirectory.Create(Node, 'New directory');
  if (assigned(TempNode)) then TempNode.Delete;
end;
procedure TFormMain.Newdirectory1Click(Sender: TObject);
begin
  DMod.ToServer('!NEWDIR' + LF + NewDirectory.Serialization + LF + '!END-NEWDIR' + LF);
end;

// -----------------
// -- Save & Load --
// -----------------

procedure TFormMain.LoadBtnClick(Sender: TObject);
var SaveFile: textfile;
    Str: String;
    Datas: TStringList;
begin
  DMod.OpenDialog.InitialDir := ExtractFilePath(Application.ExeName) + 'Saves';
  DMod.OpenDialog.Execute;
  if (FileExists(DMod.OpenDialog.FileName)) then begin
    assignfile(SaveFile, DMod.OpenDialog.FileName);
    reset(SaveFile);
    Datas := TStringList.Create;
    while (not EOF(savefile)) do begin
      // lire une ligne
      ReadLn(savefile, Str);
      Datas.Append(Str);
    end;
    closefile(SaveFile);

    DMod.DoBufferCmd(Datas);
    Datas.Free;
  end;
end;


procedure TFormMain.SaveBtnClick(Sender: TObject);
var boucle:integer;
    SaveFile: textfile;
    JDRObject: TJDRObject;
begin
  DMod.SaveDialog.DefaultExt := '*.jdr';
  DMod.SaveDialog.FilterIndex := 1;
  DMod.SaveDialog.InitialDir := ExtractFilePath(Application.ExeName) + 'Saves';
  DMod.SaveDialog.Execute;
  if (DMod.SaveDialog.FileName <> '') then begin
    assignfile(SaveFile, DMod.SaveDialog.FileName);
    rewrite(savefile);
    writeln(savefile, '!LOAD');
    writeln(savefile, SaveClocksSerial);
    for boucle := 0 to GameObj.Items.Count - 1 do begin
      JDRObject := GameObj.Items[boucle].Data;
      if (assigned(JDRObject)) then writeln(savefile, JDRObject.Serialization);
    end;
    writeln(savefile, '!END-LOAD');
    closefile(savefile);
  end;
end;


procedure TFormMain.ServeBtnClick(Sender: TObject);
var Active: Boolean;
begin
  Active := (ClientBtn.Down or ServeBtn.Down);
  if (Active) then begin
    CtrlTree.Items[CCTRL_SER].ImageIndex := CICON_YELLOW;
    CtrlTree.Items[CCTRL_CLI].ImageIndex := CICON_YELLOW;
    CtrlTree.Repaint;
  end;
  IP.Enabled := not Active;
  Port.Enabled := not Active;
  LoadBtn.Enabled := not Active;
  TimeBox.Enabled := (not ClientBtn.Down);
  GameMinutes.Enabled := (not ClientBtn.Down);

  if (ServeBtn.Down) then
    DMod.OpenServer(round(DMod.CVal(Port.Text)))
  else
    DMod.CloseServer;

  if (ClientBtn.Down) then
    DMod.OpenClient(IP.Text, round(DMod.CVal(Port.Text)))
  else
    if (not Active) then DMod.CloseClient;
end;


procedure TFormMain.FinderClick(Sender: TObject);
var Boucle: Integer;
    JDRObject: TJDRObject;
begin
  for Boucle:=0 to GameObj.Items.Count-1 do begin
    JDRObject := GameObj.Items[Boucle].Data;
    if (assigned(JDRObject)) then begin
      if (JDRObject = ControledObject) then GameObj.Select(GameObj.Items[Boucle]);
    end;
  end;
end;

// ----- CHAT ------

procedure TFormMain.ChatKeyPress(Sender: TObject; var Key: Char);
var Str: String;
begin
  if (ord(Key) = 13) then begin
    Str := '<' + Nick.Text + '> ' + Chat.Text;
    DMod.ToServer('!CHAT' + LF + Str + LF + '!END-CHAT' + LF);
    FormMain.ChatMemo.Lines.Append(Str);
    Chat.Text := '';
  end;
end;

procedure TFormMain.GameObjEdited(Sender: TObject; Node: TTreeNode; var S: String);
var JDRObject: TJDRObject;
    Directory: TDirectory;
begin
  JDRObject := Node.Data;
  if (JDRObject is TDirectory) then begin
    Directory := TDirectory(JDRObject);
    Directory.Modified := True;
    Directory.Name := S;
  end;
end;

// ------- TIME MAP --------

// TotalTime = Temps total de jeu prvu en minutes
// DayTime   = Temps d'une journe JDR
// PercDawn  = Pourcentage de crpuscule sur une journe (x2 matin/soir)
// PercNight = Pourcentage de nuit sur une journe
// Result : 1= Jour / 2= Soir / 3= Nuit / 4= Matin
procedure TFormMain.DrawTimeMap;
var VTotalTime, VDayTime, VPercLight, VPercDawn, VPercNight, VHoursTime, VGameMinutes: Integer;
    JDRObject: TJDRObject;
    Event: TEvent;
    Boucle: Integer;
    FullDay: Integer;
    Pos: TPoint;
    BorneA, BorneB: Double;

  function DayMode(Value: Integer): Integer;
  var InDay: Integer;
  begin
    InDay := trunc((Value mod FullDay) / FullDay * 100);
    if (InDay < VPercLight) then Result := 1
    else begin
      dec(InDay, VPercLight);
      if (InDay < VPercDawn) then Result := 2
      else begin
        dec(InDay, VPercDawn);
        if (InDay < VPercNight) then Result := 3
        else Result := 4;
      end;
    end;
  end;
  function CalcGameClock: String;
  var Hours, Mins: Integer;
      Index: Double;
  begin
    Index := VGameMinutes / VDayTime * VHoursTime;
    Hours := (trunc(Index) + (VHoursTime div 3)) mod VHoursTime;
    Mins := trunc(frac(Index) * 60);
    Result := DMod.CStr(Hours) + ':';
    if (Hours < 10) then Result := '0' + Result;
    if (Mins < 10) then Result := Result + '0';
    Result := Result + DMod.CStr(Mins);
  end;
  function CalcOffset(Perc: Double): Integer;
  begin
    Result := round(Perc * (TimeMap.Width - 1));
  end;

begin
  // Pre-calcul
  VTotalTime := Round(DMod.CVal(TotalTime.Text));
  VDayTime := Round(DMod.CVal(DayTime.Text));
  VPercDawn := Round(DMod.CVal(PercDawn.Text));
  VPercNight := Round(DMod.CVal(PercNight.Text));
  VGameMinutes := Round(DMod.CVal(GameMinutes.Text));
  VHoursTime  := Round(DMod.CVal(HoursTime.Text));

  if (VTotalTime = 0) then VTotalTime := 1;
  FullDay := round(((TimeMap.Width - 1) / (VTotalTime / VDayTime)));
  if (VPercNight > 100) then VPercNight := 100;
  if (VPercDawn > 50) then VPercDawn := 50;
  if (VPercNight + (VPercDawn * 2) > 100) then VPercDawn := 0;
  VPercLight := 100 - VPercNight - (VPercDawn * 2);

  TotalTime.Text := DMod.CStr(VTotalTime);
  DayTime.Text := DMod.CStr(VDayTime);
  PercDawn.Text := DMod.CStr(VPercDawn);
  PercNight.Text := DMod.CStr(VPercNight);
  PercLight.Text := DMod.CStr(VPercLight);
  GameClock.Text := CalcGameClock;

  with TimeMap.Canvas do begin
    for Boucle:=0 to TimeMap.Width do begin
      case DayMode(Boucle) of
      1: Pen.Color := clBlue;
      2: Pen.Color := clMaroon;
      3: Pen.Color := clNavy;
      4: Pen.Color := clOlive;
      end;
      Pos.X := Boucle; Pos.Y := 0; PenPos := Pos;
      LineTo(Boucle, TimeMap.Height);
    end;
    // Affichage de la position actuelle dans la timeline
    BorneA := VGameMinutes / VTotalTime;
    BorneB := (VGameMinutes + 1) / VTotalTime;

    Pen.Color := clWhite;
    Pos.X := CalcOffset(BorneA); Pos.Y := 0; PenPos := Pos;
    LineTo(Pos.X, TimeMap.Height);
    Pos.Y := TimeMap.Height div 2; PenPos := Pos;
    LineTo(CalcOffset(BorneB), Pos.Y);
    // Gestion des vnements
    Brush.Style := bsClear;
    Font.Color := clYellow;
    for Boucle:=0 to GameObj.Items.Count-1 do begin
      JDRObject := GameObj.Items[Boucle].Data;
      if (assigned(JDRObject)) then if (JDRObject is TEvent) then begin
        Event := TEvent(JDRObject);
        if (Event.Active) then begin
          if ((Event.TimePerc >= BorneA) and (Event.TimePerc < BorneB)) then ActiveEvent(Event);
          Pos.X := CalcOffset(Event.TimePerc) - 1; Pos.Y := 0; PenPos := Pos;
          TextOut(Pos.X, Pos.Y, Event.Index);
        end;
      end;
    end;
  end;
end;

procedure TFormMain.TotalTimeExit(Sender: TObject);
begin
  DrawTimeMap;
  DMod.TimeCnt := 0;
end;
procedure TFormMain.DayTimeExit(Sender: TObject);
begin
  DrawTimeMap;
  DMod.TimeCnt := 0;
end;
procedure TFormMain.PercLightExit(Sender: TObject);
begin
  DrawTimeMap;
  DMod.TimeCnt := 0;
end;
procedure TFormMain.PercDawnExit(Sender: TObject);
begin
  DrawTimeMap;
  DMod.TimeCnt := 0;
end;
procedure TFormMain.PercNightExit(Sender: TObject);
begin
  DrawTimeMap;
  DMod.TimeCnt := 0;
end;
procedure TFormMain.GameMinutesExit(Sender: TObject);
begin
  DrawTimeMap;
  // Force l'envoi de l'horloge sur le rseau
  DMod.TimeCnt := 0;
end;
function TFormMain.SaveClocksSerial: String;
begin
  Result := 'Clk;' + RealClock.Text + ';' + TotalTime.Text + ';' + DayTime.Text + ';' + HoursTime.Text + ';' +
            PercLight.Text + ';' + PercDawn.Text + ';' + PercNight.Text + ';' + GameMinutes.Text + ';';
end;
procedure TFormMain.LoadClocksSerial(Serial: String);
begin
  With DMod do if (Parser(Serial, 0) = 'Clk') then begin
    RealClock.Text := Parser(Serial, 1);
    TotalTime.Text := Parser(Serial, 2);
    DayTime.Text := Parser(Serial, 3);
    HoursTime.Text := Parser(Serial, 4);
    PercLight.Text := Parser(Serial, 5);
    PercDawn.Text := Parser(Serial, 6);
    PercNight.Text := Parser(Serial, 7);
    GameMinutes.Text := Parser(Serial, 8);
  end;
  DrawTimeMap;
end;

procedure TFormMain.TimePanelColor;
begin
  if (TimePlayBtn.Down) then PanelTime.Color := clNavy else PanelTime.Color := clFuchsia;
end;
procedure TFormMain.TimePlayBtnClick(Sender: TObject);
begin
  if (TimePlayBtn.Down) then DMod.ToServer('!TIMEDOWN' + LF) else DMod.ToServer('!TIMEUP' + LF);
  TimePanelColor;
  DrawTimeMap;
end;


// Activation d'un event

procedure TFormMain.TimeMapDragDrop(Sender, Source: TObject; X, Y: Integer);
var JDRObject: TJDRObject;
    Event: TEvent;
begin
  if (Source is TTreeView) then begin
    JDRObject := TTreeView(Source).Selected.Data;
    if (JDRObject is TEvent) then begin
      Event := TEvent(JDRObject);
      Event.TimePerc := X / TimeMap.Width;
      Event.Active := True;
      Event.Modified := True;
    end;
  end;
  DrawTimeMap;
end;
procedure TFormMain.TimeMapDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var JDRObject: TJDRObject;
begin
  Accept := False;
  // Si c'est un objet de l'arbre, on l'accepte
  if (Source is TTreeView) then begin
    JDRObject := TTreeView(Source).Selected.Data;
    if (JDRObject is TEvent) then Accept := True;
  end;
  // Autre chose, on refuse le drop
end;

procedure TFormMain.ActiveEvent(Event: TEvent);
var Str: String;
    Boucle: Integer;
begin
  if ((Event.Active) and (TimePlayBtn.Down) and (DMod.Server.Active)) then begin
    Str := '*EVENT*' + Event.Name + ': ';
    for boucle:=0 to Event.Comments.Count - 1 do Str := Str + Event.Comments[boucle] + ' / ';
    ChatMemo.Lines.Append(Str);
    DMod.ToServer('!CHAT' + LF + Str + LF + '!END-CHAT' + LF);
  end;
end;

end.

